<?php

namespace Drupal\Tests\courier\Functional;

use Drupal\Core\Url;
use Drupal\courier\Entity\MessageQueueItem;
use Drupal\Tests\BrowserTestBase;

/**
 * Courier maintenance form web test.
 *
 * @group courier
 */
class CourierMaintenanceFormTest extends BrowserTestBase {

  /**
   * {@inheritdoc}
   */
  protected static $modules = ['courier'];

  /**
   * {@inheritdoc}
   */
  protected $defaultTheme = 'stark';

  /**
   * Test message queue items are deleted.
   */
  public function testMessageDelete() {
    $user = $this->drupalCreateUser(['administer courier']);
    $this->drupalLogin($user);

    $requestTime = \Drupal::time()->getRequestTime();

    MessageQueueItem::create(['created' => $requestTime + 3600])->save();
    MessageQueueItem::create(['created' => $requestTime + 3600])->save();
    MessageQueueItem::create(['created' => $requestTime + 3600])->save();
    MessageQueueItem::create(['created' => $requestTime - 3600])->save();
    MessageQueueItem::create(['created' => $requestTime - 3600])->save();

    $edit = [
      'delete_age' => 60,
    ];
    $this->drupalGet(Url::fromRoute('courier.admin.maintenance'));
    $this->submitForm($edit, t('Delete messages'));
    $this->assertSession()->responseContains('2 messages deleted.');
  }

}
